"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.tsx
var src_exports = {};
__export(src_exports, {
  Anchor: () => Anchor,
  Button: () => Button,
  ButtonGroup: () => ButtonGroup,
  Card: () => Card,
  CardButton: () => CardButton,
  Checkbox: () => Checkbox,
  Code: () => Code,
  CodeBlock: () => CodeBlock,
  Icon: () => Icon,
  InputContainer: () => InputContainer,
  Label: () => Label,
  Overlay: () => Overlay,
  Radio: () => Radio,
  Spinner: () => Spinner,
  SpinnerContext: () => SpinnerContext,
  SpinnerProvider: () => SpinnerProvider,
  Table: () => Table2,
  Text: () => Text,
  VirtualizedTable: () => VirtualizedTable,
  useIsDarkMode: () => useIsDarkMode,
  useSpinner: () => useSpinner,
  useSpinnerContext: () => useSpinnerContext,
  withSpinner: () => withSpinner
});
module.exports = __toCommonJS(src_exports);

// src/anchor/anchor.tsx
var import_react = require("react");

// src/icon/icon.fx.ts
var getIconClassName = (variant, className) => {
  const trimmed = variant == null ? void 0 : variant.trim();
  return trimmed === "filled" ? `material-icons ${className || ""}`.trimEnd() : `material-icons-${trimmed} ${className || ""}`.trimEnd();
};

// src/icon/icon.styles.ts
var import_core = require("@waystone/core");
var IconSize = /* @__PURE__ */ ((IconSize2) => {
  IconSize2["sm"] = "1em";
  IconSize2["md"] = "1.5em";
  IconSize2["lg"] = "2em";
  return IconSize2;
})(IconSize || {});
var convert = (size) => IconSize[import_core.Size[size]];
var iconCss = (props) => {
  const css = {
    verticalAlign: "middle",
    color: props.color || "inherit",
    fontSize: "inherit"
  };
  if (props.size) {
    css.fontSize = `${convert(props.size)} !important`;
  }
  return css;
};

// src/icon/icon.tsx
var import_jsx_runtime = require("theme-ui/jsx-runtime");
var Icon = (_a) => {
  var _b = _a, {
    className,
    name,
    variant = "filled",
    size = "md",
    color = "inherit"
  } = _b, rest = __objRest(_b, [
    "className",
    "name",
    "variant",
    "size",
    "color"
  ]);
  return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
    "i",
    __spreadProps(__spreadValues({
      sx: iconCss({ size, color }),
      className: getIconClassName(variant, className)
    }, rest), {
      children: name
    })
  );
};

// src/anchor/anchor.styles.tsx
var import_core2 = require("@waystone/core");
var outline = (0, import_core2.getOutlineCss)();
var anchorCss = __spreadProps(__spreadValues({
  paddingX: "xs",
  textDecoration: "none",
  borderBottom: "1px solid",
  borderBottomColor: "highlight",
  color: "inherit",
  transition: "all 100ms",
  fontFamily: "inherit",
  fontWeight: "inherit",
  fontSize: "inherit",
  cursor: "pointer"
}, outline.base), {
  ":hover": {
    backgroundColor: "ghost",
    borderTopLeftRadius: "sm",
    borderTopRightRadius: "sm"
  },
  ":focus-visible": __spreadValues({
    backgroundColor: "ghost",
    borderTopLeftRadius: "sm",
    borderTopRightRadius: "sm"
  }, outline.focused[":enabled:not(active):focus-visible"])
});
var undecoratedAnchorCss = {
  display: "flex",
  justifyContent: "center",
  alignItems: "center",
  cursor: "pointer"
};

// src/anchor/anchor.tsx
var import_jsx_runtime2 = require("theme-ui/jsx-runtime");
var renderInternalAnchor = (_a, ref) => {
  var _b = _a, {
    children,
    noDecoration
  } = _b, rest = __objRest(_b, [
    "children",
    "noDecoration"
  ]);
  return /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("a", __spreadProps(__spreadValues({ ref }, rest), { sx: noDecoration ? undecoratedAnchorCss : anchorCss, children }));
};
var InternalAnchor = (0, import_react.forwardRef)(renderInternalAnchor);
var renderExternalAnchor = (_a, ref) => {
  var _b = _a, {
    children,
    noDecoration,
    target = "_blank",
    rel = "noopener noreferrer"
  } = _b, rest = __objRest(_b, [
    "children",
    "noDecoration",
    "target",
    "rel"
  ]);
  return /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)(
    "a",
    __spreadProps(__spreadValues({
      ref
    }, rest), {
      sx: !noDecoration ? anchorCss : undecoratedAnchorCss,
      target,
      rel,
      children: [
        children,
        " ",
        /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(Icon, { name: "open_in_new", size: "sm", sx: { pb: "xs" } })
      ]
    })
  );
};
var ExternalAnchor = (0, import_react.forwardRef)(renderExternalAnchor);
var renderAnchor = (_a, ref) => {
  var _b = _a, { external = false } = _b, rest = __objRest(_b, ["external"]);
  if (external) {
    return /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(ExternalAnchor, __spreadValues({ ref }, rest));
  }
  return /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(InternalAnchor, __spreadValues({ ref }, rest));
};
var Anchor = (0, import_react.forwardRef)(renderAnchor);

// src/button/button.tsx
var import_react5 = require("react");
var import_theme_ui3 = require("theme-ui");

// src/hooks/useIsDarkMode.tsx
var import_theme_ui = require("theme-ui");
var useIsDarkMode = () => {
  const [colorMode] = (0, import_theme_ui.useColorMode)();
  const darkMode = colorMode === "dark";
  return darkMode;
};

// src/overlay/overlay.tsx
var import_color = require("@theme-ui/color");
var import_jsx_runtime3 = require("theme-ui/jsx-runtime");
var Overlay = ({ children, fullScreen = false }) => /* @__PURE__ */ (0, import_jsx_runtime3.jsx)(
  "div",
  {
    sx: {
      position: fullScreen ? "fixed" : "absolute",
      top: 0,
      left: 0,
      width: "100%",
      height: "100%",
      zIndex: "highest",
      bg: (0, import_color.alpha)("muted", 0.9),
      backdropFilter: "blur(10px)"
    },
    children: /* @__PURE__ */ (0, import_jsx_runtime3.jsx)("div", { sx: { opacity: 1 }, children })
  }
);

// src/spinner/spinner.styles.ts
var import_react2 = require("@emotion/react");
var changeContent = import_react2.keyframes`
10% { content: "⠙"; }
20% { content: "⠹"; }
30% { content: "⠸"; }
40% { content: "⠼"; }
50% { content: "⠴"; }
60% { content: "⠦"; }
70% { content: "⠧"; }
80% { content: "⠇"; }
90% { content: "⠏"; }
`;
var getSpinnerSize = (size) => {
  switch (size) {
    case "sm":
      return "1.3125rem";
    case "md":
      return "1.5em";
    case "lg":
      return "2em";
    default:
      return "1.5em";
  }
};
var spinnerCss = ({
  size,
  color,
  fullWidth
}) => {
  const css = {
    color,
    display: fullWidth ? "flex" : "inline-flex",
    width: fullWidth ? "100%" : "auto",
    height: getSpinnerSize(size || "md"),
    alignItems: "center",
    justifyContent: "center",
    aspectRatio: "1",
    ":after": {
      animation: `${changeContent} 600ms linear infinite`,
      display: "block",
      content: '"\u280B"',
      fontSize: getSpinnerSize(size || "md")
    }
  };
  return css;
};

// src/spinner/spinner.tsx
var import_jsx_runtime4 = require("theme-ui/jsx-runtime");
var Spinner = ({
  size = "md",
  color = "accent",
  fullWidth = false,
  overlay = false
}) => {
  if (overlay) {
    return /* @__PURE__ */ (0, import_jsx_runtime4.jsx)(Overlay, { children: /* @__PURE__ */ (0, import_jsx_runtime4.jsx)(
      "span",
      {
        sx: __spreadProps(__spreadValues({}, spinnerCss({ size, color, fullWidth: true })), {
          height: "100%",
          zIndex: "highest",
          position: "absolute"
        })
      }
    ) });
  }
  return /* @__PURE__ */ (0, import_jsx_runtime4.jsx)(
    "span",
    {
      role: "progressbar",
      sx: spinnerCss({ size, color, fullWidth }),
      "aria-valuetext": "Loading...",
      "aria-busy": true
    }
  );
};

// src/spinner/spinner.hoc.tsx
var import_jsx_runtime5 = require("theme-ui/jsx-runtime");
function withSpinner(WrappedComponent) {
  const ComponentWithSpinner = (props) => {
    const { loading } = props;
    return loading ? /* @__PURE__ */ (0, import_jsx_runtime5.jsx)(Spinner, __spreadValues({}, props)) : /* @__PURE__ */ (0, import_jsx_runtime5.jsx)(WrappedComponent, __spreadValues({}, props));
  };
  return ComponentWithSpinner;
}

// src/spinner/spinner.hooks.tsx
var import_react3 = __toESM(require("react"));
var import_jsx_runtime6 = require("theme-ui/jsx-runtime");
var useSpinner = (props) => {
  var _a, _b;
  const [visible, setVisible] = import_react3.default.useState((_a = props == null ? void 0 : props.initialVisible) != null ? _a : false);
  const show = () => setVisible(true);
  const hide = () => setVisible(false);
  const spinner = visible && /* @__PURE__ */ (0, import_jsx_runtime6.jsx)(Spinner, { overlay: (_b = props == null ? void 0 : props.overlay) != null ? _b : true });
  return { show, hide, spinner };
};

// src/spinner/spinner.context.tsx
var import_react4 = __toESM(require("react"));
var import_jsx_runtime7 = require("theme-ui/jsx-runtime");
var SpinnerContext = import_react4.default.createContext({});
var SpinnerProvider = ({ initialVisible = true, children }) => {
  const { show, hide, spinner } = useSpinner({ initialVisible });
  const value = import_react4.default.useMemo(() => ({ show, hide }), [show, hide]);
  return /* @__PURE__ */ (0, import_jsx_runtime7.jsxs)(SpinnerContext.Provider, { value, children: [
    children,
    spinner
  ] });
};
var useSpinnerContext = () => {
  const context = import_react4.default.useContext(SpinnerContext);
  if (!context) {
    throw new Error(
      '"useSpinnerContext" must be used within a "SpinnerProvider"'
    );
  }
  return context;
};

// src/text/text.tsx
var import_theme_ui2 = require("theme-ui");

// src/text/text.styles.ts
var textCss = ({
  inline,
  variant,
  color
}) => {
  const css = {
    display: "block",
    variant: `text.${variant}`,
    color: color || "inherit"
  };
  if (inline) {
    css.display = "inline-block";
    css.marginY = 0;
    css.marginX = 0;
  }
  return css;
};

// src/text/text.tsx
var import_jsx_runtime8 = require("theme-ui/jsx-runtime");
var Text = (_a) => {
  var _b = _a, {
    children,
    as = "span",
    inline = false,
    variant = "body",
    color
  } = _b, rest = __objRest(_b, [
    "children",
    "as",
    "inline",
    "variant",
    "color"
  ]);
  return /* @__PURE__ */ (0, import_jsx_runtime8.jsx)(import_theme_ui2.Text, __spreadProps(__spreadValues({ sx: textCss({ inline, variant, color }), as }, rest), { children }));
};

// src/button/button.fx.ts
var getTextVariant = (size) => {
  switch (size) {
    case "sm":
      return "caption";
    case "lg":
      return "eyebrow";
    default:
      return "body";
  }
};

// src/button/button.styles.ts
var import_core4 = require("@waystone/core");

// src/button/button.styles.fx.ts
var import_core3 = require("@waystone/core");
var getBackgroundColor = ({
  variant = "primary"
}) => {
  switch (variant) {
    case "ghost":
      return "ghost";
    case "link":
      return "transparent";
    case "primary":
    case "secondary":
    case "accent":
    case "highlight":
    default:
      return `${variant[0]}-400`;
  }
};
var getHoverBackgroundColor = ({
  variant = "primary",
  darkMode
}) => {
  switch (variant) {
    case "ghost":
      return darkMode ? "b-700" : "b-200";
    case "link":
      return "transparent";
    case "primary":
    case "secondary":
    case "accent":
    case "highlight":
    default:
      return `${variant[0]}-300`;
  }
};
var getActiveBackgroundColor = ({
  variant = "primary",
  darkMode
}) => {
  switch (variant) {
    case "ghost":
      return darkMode ? "b-700" : "b-200";
    case "link":
      return "transparent";
    case "primary":
    case "secondary":
    case "accent":
    case "highlight":
    default:
      return `${variant[0]}-300`;
  }
};
var getColor = (variant) => {
  switch (variant) {
    case "primary":
    case "secondary":
    case "accent":
    case "highlight":
      return "b-900";
    default:
      return "text";
  }
};
var getLinkVariantActiveColor = (darkMode) => darkMode ? "h-400" : "h-700";
var getLinkVariantHoverColor = (darkMode) => darkMode ? "h-400" : "h-700";
var getBoxShadow = ({
  variant = "primary",
  darkMode
}) => {
  if (["ghost", "link"].includes(variant)) {
    return {
      normalBoxShadow: "none",
      hoverBoxShadow: "none",
      activeBoxShadow: "none"
    };
  }
  return {
    normalBoxShadow: (0, import_core3.addDarkModeSuffix)("sm", darkMode),
    hoverBoxShadow: (0, import_core3.addDarkModeSuffix)("md", darkMode),
    activeBoxShadow: (0, import_core3.addDarkModeSuffix)("sm", darkMode)
  };
};
var getPadding = ({
  variant = "primary",
  size
}) => {
  if (variant === "link")
    return { paddingX: 0, paddingY: 0 };
  switch (size) {
    case "sm": {
      return {
        paddingX: "sm",
        paddingY: "xs"
      };
    }
    case "lg": {
      return {
        paddingX: "xl",
        paddingY: "sm"
      };
    }
    default:
      return {
        paddingX: "md",
        paddingY: "sm"
      };
  }
};

// src/button/button.styles.ts
var buttonCss = ({
  variant,
  size,
  darkMode,
  width,
  minWidth,
  maxWidth,
  fullWidth,
  active
}) => {
  const { normalBoxShadow, hoverBoxShadow, activeBoxShadow } = getBoxShadow({
    variant,
    darkMode
  });
  const { paddingX, paddingY } = getPadding({ variant, size });
  const color = getColor(variant);
  const outline3 = (0, import_core4.getOutlineCss)();
  const isLink = variant === "link";
  const hoverCss = {
    color: isLink ? getLinkVariantHoverColor(darkMode) : color,
    boxShadow: hoverBoxShadow,
    backgroundColor: getHoverBackgroundColor({ variant, darkMode })
  };
  const focusCss = {
    color: isLink ? getLinkVariantActiveColor(darkMode) : color,
    boxShadow: activeBoxShadow,
    backgroundColor: getActiveBackgroundColor({ variant, darkMode })
  };
  const activeCss = {
    color: isLink ? getLinkVariantActiveColor(darkMode) : color,
    boxShadow: activeBoxShadow,
    backgroundColor: getActiveBackgroundColor({ variant, darkMode })
  };
  const baseCss = __spreadProps(__spreadValues({
    display: "flex",
    flexWrap: "nowrap",
    alignItems: "center",
    justifyContent: "center",
    color,
    backgroundColor: getBackgroundColor({ variant, darkMode }),
    paddingX,
    paddingY,
    width: fullWidth ? "100%" : width,
    maxWidth: !fullWidth && maxWidth,
    minWidth: !fullWidth && minWidth,
    boxShadow: normalBoxShadow,
    margin: 0,
    cursor: "pointer",
    transition: "all 200ms ease"
  }, outline3.base), {
    ":enabled:hover": __spreadValues({}, hoverCss),
    ":not(active):focus-visible": __spreadValues(__spreadValues({}, focusCss), outline3.focused[":enabled:not(active):focus-visible"]),
    ":enabled:active": __spreadValues(__spreadValues({}, activeCss), outline3.active[":enabled:active"]),
    ":disabled": {
      color: "b-400",
      backgroundColor: !isLink && "muted",
      cursor: "not-allowed"
    }
  });
  if (active) {
    return __spreadValues(__spreadValues({}, baseCss), activeCss);
  }
  return baseCss;
};
var buttonAddonCss = ({
  hasChildren,
  variant,
  size
}) => ({
  marginRight: hasChildren && "sm",
  marginY: getPadding({ variant, size })
});

// src/button/button.tsx
var import_jsx_runtime9 = require("theme-ui/jsx-runtime");
var Button = (_a) => {
  var _b = _a, {
    children,
    icon,
    width,
    minWidth,
    maxWidth,
    fullWidth,
    variant = "primary",
    size = "sm",
    hideContentWhileLoading = false,
    loading = false,
    disabled = false,
    active = false
  } = _b, rest = __objRest(_b, [
    "children",
    "icon",
    "width",
    "minWidth",
    "maxWidth",
    "fullWidth",
    "variant",
    "size",
    "hideContentWhileLoading",
    "loading",
    "disabled",
    "active"
  ]);
  const isDarkMode = useIsDarkMode();
  const shouldBeDisabled = disabled || loading;
  const shouldRenderChildren = !!children && (!loading || !hideContentWhileLoading);
  const shouldRenderIcon = !loading && icon;
  const buttonSx = (0, import_react5.useMemo)(() => {
    const buttonCssParams = {
      variant,
      size,
      darkMode: isDarkMode,
      active,
      width,
      minWidth,
      maxWidth,
      fullWidth
    };
    return buttonCss(buttonCssParams);
  }, [variant, size, isDarkMode, active, width, minWidth, maxWidth, fullWidth]);
  const buttonAddonSx = (0, import_react5.useMemo)(() => {
    const buttonAddonCssParams = {
      variant,
      size,
      hasChildren: shouldRenderChildren
    };
    return buttonAddonCss(buttonAddonCssParams);
  }, [variant, size, shouldRenderChildren]);
  const spinnerSize = size === "sm" ? "sm" : "md";
  return /* @__PURE__ */ (0, import_jsx_runtime9.jsxs)(import_theme_ui3.Button, __spreadProps(__spreadValues({ sx: buttonSx, disabled: shouldBeDisabled }, rest), { children: [
    loading && /* @__PURE__ */ (0, import_jsx_runtime9.jsx)(import_theme_ui3.Flex, { sx: buttonAddonSx, children: /* @__PURE__ */ (0, import_jsx_runtime9.jsx)(Spinner, { size: spinnerSize }) }),
    shouldRenderIcon && /* @__PURE__ */ (0, import_jsx_runtime9.jsx)(import_theme_ui3.Flex, { sx: buttonAddonSx, children: /* @__PURE__ */ (0, import_jsx_runtime9.jsx)(Icon, __spreadValues({ size: "sm" }, icon)) }),
    shouldRenderChildren && /* @__PURE__ */ (0, import_jsx_runtime9.jsx)(Text, { variant: getTextVariant(size), inline: true, children })
  ] }));
};

// src/button-group/buttonGroup.tsx
var import_theme_ui4 = require("theme-ui");

// src/button-group/buttonGroup.styles.ts
var buttonGroupCss = {
  gap: "xs",
  padding: "xs",
  borderRadius: "sm",
  backgroundColor: "ghost",
  width: "fit-content"
};

// src/button-group/buttonGroup.tsx
var import_jsx_runtime10 = require("theme-ui/jsx-runtime");
var import_theme_ui5 = require("theme-ui");
var ButtonGroup = ({
  activeButton,
  buttons,
  onChange,
  size
}) => /* @__PURE__ */ (0, import_jsx_runtime10.jsx)(import_theme_ui4.Flex, { sx: buttonGroupCss, children: buttons.map((button) => {
  if (!button.id) {
    throw new Error("You must provide an `id` for each button");
  }
  const key = button.id;
  return /* @__PURE__ */ (0, import_theme_ui5.createElement)(
    Button,
    __spreadProps(__spreadValues({}, button), {
      key,
      size,
      variant: "ghost",
      active: key === activeButton,
      onClick: (e) => {
        if (onChange)
          onChange({ e, clicked: key });
      }
    })
  );
}) });

// src/card/card.tsx
var import_theme_ui6 = require("theme-ui");

// src/card/card.styles.ts
var cardContainerCss = (_a) => {
  var _b = _a, {
    fullWidth,
    width,
    minWidth,
    maxWidth,
    noShadow,
    darkMode
  } = _b, rest = __objRest(_b, [
    "fullWidth",
    "width",
    "minWidth",
    "maxWidth",
    "noShadow",
    "darkMode"
  ]);
  return __spreadValues({
    borderRadius: "md",
    width: fullWidth ? "100%" : width || "auto",
    minWidth: !fullWidth && minWidth,
    maxWidth: !fullWidth && maxWidth,
    backgroundColor: darkMode ? "b-600" : "b-50",
    boxShadow: !noShadow && "md",
    overflowY: "auto"
  }, rest);
};
var coverImageCss = ({
  url,
  size = "cover",
  repeat = "no-repeat",
  position = "center",
  height = "md",
  fallbackColor = "secondary"
}) => ({
  backgroundImage: `url(${url})`,
  backgroundColor: fallbackColor,
  backgroundSize: size,
  backgroundRepeat: repeat,
  backgroundPosition: position,
  width: "100%",
  height
});
var cardContentCss = (noPadding) => ({
  padding: noPadding ? 0 : "md"
});

// src/card/card.tsx
var import_jsx_runtime11 = require("theme-ui/jsx-runtime");
var Card = (_a) => {
  var _b = _a, {
    children,
    coverImage,
    noPadding
  } = _b, rest = __objRest(_b, [
    "children",
    "coverImage",
    "noPadding"
  ]);
  const [mode] = (0, import_theme_ui6.useColorMode)();
  const darkMode = mode === "dark";
  return /* @__PURE__ */ (0, import_jsx_runtime11.jsxs)(
    "div",
    {
      sx: cardContainerCss(__spreadProps(__spreadValues({}, rest), {
        darkMode
      })),
      children: [
        coverImage && /* @__PURE__ */ (0, import_jsx_runtime11.jsx)("div", { sx: coverImageCss(coverImage), role: "img" }),
        /* @__PURE__ */ (0, import_jsx_runtime11.jsx)("div", { sx: cardContentCss(noPadding), children })
      ]
    }
  );
};

// src/card-button/cardButton.tsx
var import_core5 = require("@waystone/core");
var import_jsx_runtime12 = require("theme-ui/jsx-runtime");
var CardButton = (_a) => {
  var _b = _a, {
    children,
    fullWidth,
    width,
    minWidth,
    maxWidth,
    noShadow,
    disabled,
    loading,
    onClick
  } = _b, rest = __objRest(_b, [
    "children",
    "fullWidth",
    "width",
    "minWidth",
    "maxWidth",
    "noShadow",
    "disabled",
    "loading",
    "onClick"
  ]);
  const darkMode = useIsDarkMode();
  const outline3 = (0, import_core5.getOutlineCss)();
  const cardCss = __spreadProps(__spreadValues(__spreadValues(__spreadValues({
    position: "relative",
    paddingX: "md",
    paddingY: "md",
    border: "none",
    borderRadius: "md",
    color: "text",
    width: fullWidth ? "100%" : width || "auto",
    minWidth: !fullWidth && minWidth,
    maxWidth: !fullWidth && maxWidth,
    backgroundColor: darkMode ? "b-600" : "b-50",
    boxShadow: !noShadow && "md",
    cursor: "pointer",
    overflow: "hidden",
    textAlign: "left",
    transition: "all 200ms"
  }, outline3.base), outline3.focused), rest), {
    ":enabled:hover": {
      backgroundColor: darkMode ? "b-500" : "b-100"
    },
    ":enabled:active": __spreadValues({
      backgroundColor: darkMode ? "b-400" : "b-200"
    }, outline3.active[":enabled:active"]),
    ":disabled": {
      color: "b-400",
      backgroundColor: "muted",
      cursor: "not-allowed"
    }
  });
  return /* @__PURE__ */ (0, import_jsx_runtime12.jsxs)(
    "button",
    {
      sx: cardCss,
      onClick,
      type: "button",
      disabled: disabled || loading,
      children: [
        loading && /* @__PURE__ */ (0, import_jsx_runtime12.jsx)(Spinner, { overlay: true }),
        children
      ]
    }
  );
};

// src/code/code.tsx
var import_theme_ui7 = require("theme-ui");

// src/code/code.styles.ts
var codeCss = (darkMode) => ({
  variant: "text.mono",
  fontSize: "caption",
  backgroundColor: darkMode ? "b-600" : "b-200",
  borderRadius: "sm",
  px: "xs",
  py: 2,
  color: darkMode ? "highlight" : "b-600"
});

// src/code/code.tsx
var import_jsx_runtime13 = require("theme-ui/jsx-runtime");
var Code = ({ children }) => {
  const [mode] = (0, import_theme_ui7.useColorMode)();
  return /* @__PURE__ */ (0, import_jsx_runtime13.jsx)("code", { sx: codeCss(mode === "dark"), children });
};

// src/code-block/codeBlock.tsx
var import_syntax_highlighter = require("@waystone/syntax-highlighter");
var import_react6 = require("react");

// src/code-block/codeBlock.fx.ts
var copy = (text) => {
  navigator.clipboard.writeText(text);
};

// src/code-block/codeBlock.styles.ts
var import_core6 = require("@waystone/core");
var codeBlockContainerCss = {
  backgroundColor: "b-600",
  mb: "lg",
  mx: "md",
  borderRadius: "md",
  variant: "text.monospace",
  display: "block",
  position: "relative",
  overflow: "clip"
};
var codeBlockLanguageCss = {
  variant: "text.small",
  letterSpacing: 1.25,
  fontWeight: "medium",
  position: "absolute",
  top: 0,
  left: "1.5rem",
  backgroundColor: "a-600",
  padding: "xs",
  color: "b-50",
  textTransform: "uppercase",
  boxShadow: "sm-dark",
  borderBottomLeftRadius: "sm",
  borderBottomRightRadius: "sm",
  pointerEvents: "none"
};
var outline2 = (0, import_core6.getOutlineCss)();
var codeBlockCopyButtonCss = __spreadProps(__spreadValues(__spreadValues({
  variant: "text.small",
  letterSpacing: 1.25,
  fontWeight: "medium",
  position: "absolute",
  top: 0,
  right: "1.5rem",
  padding: "xs",
  background: "b-500",
  boxShadow: "sm-dark",
  border: "none",
  borderBottomLeftRadius: "sm",
  borderBottomRightRadius: "sm",
  color: "b-50",
  textTransform: "uppercase",
  cursor: "pointer",
  transition: "all 200ms"
}, outline2.base), outline2.focused), {
  ":hover": {
    background: "b-400"
  },
  ":active": __spreadValues({
    background: "b-300"
  }, outline2.active[":enabled:active"])
});
var codeBlockCaptionCss = {
  position: "absolute",
  variant: "text.caption",
  textAlign: "center",
  bottom: 0,
  left: 0,
  right: 0,
  padding: "xs",
  backgroundColor: "b-700",
  color: "b-50"
};

// src/code-block/codeBlock.tsx
var import_jsx_runtime14 = require("theme-ui/jsx-runtime");
var CodeBlock = ({
  language,
  wordWrap = false,
  caption,
  children,
  styleName = "tomorrowNightBlue"
}) => {
  const [iconName, setIconName] = (0, import_react6.useState)("content_copy");
  const handleCopy = () => {
    copy(children);
    setIconName("done");
  };
  const handleBlur = () => {
    setIconName("content_copy");
  };
  return /* @__PURE__ */ (0, import_jsx_runtime14.jsxs)("div", { sx: codeBlockContainerCss, children: [
    language && /* @__PURE__ */ (0, import_jsx_runtime14.jsx)("div", { sx: codeBlockLanguageCss, children: language }),
    /* @__PURE__ */ (0, import_jsx_runtime14.jsx)(
      "button",
      {
        sx: codeBlockCopyButtonCss,
        type: "button",
        onClick: handleCopy,
        onBlur: handleBlur,
        children: /* @__PURE__ */ (0, import_jsx_runtime14.jsx)(Icon, { name: iconName })
      }
    ),
    /* @__PURE__ */ (0, import_jsx_runtime14.jsx)(
      import_syntax_highlighter.SyntaxHighlighter,
      {
        wrapLines: wordWrap,
        language,
        styleName,
        children
      }
    ),
    caption && /* @__PURE__ */ (0, import_jsx_runtime14.jsx)("div", { sx: codeBlockCaptionCss, children: caption })
  ] });
};

// src/forms/inputs/checkbox/checkbox.tsx
var import_react7 = require("react");
var import_jsx_runtime15 = require("theme-ui/jsx-runtime");
var Checkbox = (_a) => {
  var _b = _a, {
    indeterminate,
    checked
  } = _b, rest = __objRest(_b, [
    "indeterminate",
    "checked"
  ]);
  const ref = (0, import_react7.useRef)(null);
  (0, import_react7.useEffect)(() => {
    if (ref.current) {
      ref.current.indeterminate = !!indeterminate;
    }
  }, [ref, checked, indeterminate]);
  return /* @__PURE__ */ (0, import_jsx_runtime15.jsx)(
    "input",
    __spreadValues({
      sx: {
        cursor: rest.disabled ? "not-allowed" : "pointer"
      },
      type: "checkbox",
      ref,
      checked
    }, rest)
  );
};

// src/forms/inputs/container/inputContainer.tsx
var import_theme_ui8 = require("theme-ui");

// src/label/label.tsx
var import_jsx_runtime16 = require("theme-ui/jsx-runtime");
var Label = ({ htmlFor, children }) => {
  const darkMode = useIsDarkMode();
  const labelCss2 = {
    textTransform: "capitalize",
    color: darkMode ? "b-300" : "b-500",
    fontWeight: "medium",
    fontSize: "caption",
    letterSpacing: "0.1em"
  };
  return /* @__PURE__ */ (0, import_jsx_runtime16.jsx)("label", { sx: labelCss2, htmlFor, children });
};

// src/forms/inputs/container/inputContainer.fx.ts
var getIconName = (variant) => {
  switch (variant) {
    case "success":
      return "check_circle";
    case "error":
      return "error";
    case "warning":
      return "warning";
    default:
      return "info";
  }
};
var getVariantColor = (variant) => variant ? `${variant}-400` : "b-400";

// src/forms/inputs/container/inputContainer.styles.ts
var inputContainerCss = ({
  width,
  minWidth,
  maxWidth
}) => {
  const baseCss = {
    flexDirection: "column"
  };
  return __spreadProps(__spreadValues({}, baseCss), { width, minWidth, maxWidth });
};
var labelContainerCss = {
  justifyContent: "space-between",
  alignItems: "baseline",
  marginBottom: "xs"
};
var labelCss = {
  alignItems: "center",
  gap: "xs"
};

// src/forms/inputs/container/inputContainer.tsx
var import_jsx_runtime17 = require("theme-ui/jsx-runtime");
var InputContainer = (_a) => {
  var _b = _a, {
    id,
    label,
    children,
    helpText,
    variant,
    required
  } = _b, rest = __objRest(_b, [
    "id",
    "label",
    "children",
    "helpText",
    "variant",
    "required"
  ]);
  const color = getVariantColor(variant);
  return /* @__PURE__ */ (0, import_jsx_runtime17.jsxs)(import_theme_ui8.Flex, { sx: inputContainerCss(__spreadValues({}, rest)), children: [
    /* @__PURE__ */ (0, import_jsx_runtime17.jsxs)(import_theme_ui8.Flex, { sx: labelContainerCss, children: [
      /* @__PURE__ */ (0, import_jsx_runtime17.jsxs)(import_theme_ui8.Flex, { sx: labelCss, children: [
        /* @__PURE__ */ (0, import_jsx_runtime17.jsx)(Label, { htmlFor: id, children: label }),
        variant && /* @__PURE__ */ (0, import_jsx_runtime17.jsx)(Icon, { color, name: getIconName(variant), size: "sm" })
      ] }),
      required && /* @__PURE__ */ (0, import_jsx_runtime17.jsx)(Text, { variant: "small", color: "error-400", inline: true, children: "required" })
    ] }),
    children,
    helpText && /* @__PURE__ */ (0, import_jsx_runtime17.jsx)(Text, { variant: "small", color, inline: true, children: helpText })
  ] });
};

// src/forms/inputs/radio/radio.tsx
var import_react8 = require("react");
var import_jsx_runtime18 = require("theme-ui/jsx-runtime");
var Radio = (0, import_react8.forwardRef)((props, ref) => /* @__PURE__ */ (0, import_jsx_runtime18.jsx)("input", __spreadValues({ ref, type: "radio" }, props)));
Radio.displayName = "Radio";

// src/table/table.tsx
var import_react_table3 = require("@tanstack/react-table");
var import_react_virtual = require("@tanstack/react-virtual");
var import_utils = require("@waystone/utils");
var import_react13 = require("react");

// src/table/table.body.tsx
var import_react12 = require("react");

// src/table/table.cell.tsx
var import_react_table = require("@tanstack/react-table");
var import_react9 = require("react");
var import_jsx_runtime19 = require("theme-ui/jsx-runtime");
var TableCell = ({
  cell
}) => {
  const size = (0, import_react9.useMemo)(() => cell.column.getSize(), [cell.column]);
  return /* @__PURE__ */ (0, import_jsx_runtime19.jsx)(
    "td",
    {
      sx: {
        minWidth: size,
        maxWidth: size,
        paddingY: "xs",
        paddingX: "md"
      },
      children: (0, import_react_table.flexRender)(cell.column.columnDef.cell, cell.getContext())
    }
  );
};

// src/table/table.row.tsx
var import_react10 = require("react");
var import_jsx_runtime20 = require("theme-ui/jsx-runtime");
var getBackgroundColor2 = (darkMode, disabled) => {
  if (darkMode) {
    return disabled ? "b-600" : "b-700";
  }
  return disabled ? "b-200" : "b-100";
};
var TableRowContent = ({ disabled = false, cells }) => {
  const darkMode = useIsDarkMode();
  const backgroundColor = (0, import_react10.useMemo)(
    () => getBackgroundColor2(darkMode, disabled),
    [darkMode, disabled]
  );
  return /* @__PURE__ */ (0, import_jsx_runtime20.jsx)(
    "tr",
    {
      sx: {
        backgroundColor,
        color: disabled ? "b-400" : "text"
      },
      children: cells
    }
  );
};
var TableRow = (0, import_react10.memo)(TableRowContent);

// src/table/table.row.subComponent.tsx
var import_react11 = require("react");
var import_jsx_runtime21 = require("theme-ui/jsx-runtime");
var TableRowSubComponentContent = ({
  colSpan,
  visible,
  children
}) => {
  if (!visible || !children) {
    return null;
  }
  return /* @__PURE__ */ (0, import_jsx_runtime21.jsx)("tr", { children: /* @__PURE__ */ (0, import_jsx_runtime21.jsx)("td", { sx: { padding: "xs" }, colSpan, children }) });
};
var TableRowSubComponent = (0, import_react11.memo)(TableRowSubComponentContent);

// src/table/table.body.tsx
var import_jsx_runtime22 = require("theme-ui/jsx-runtime");
var TableBody = ({
  renderSubComponent,
  rows,
  virtualizer
}) => {
  var _a, _b;
  if (virtualizer) {
    const { getTotalSize, getVirtualItems } = virtualizer;
    const virtualRows = getVirtualItems();
    const totalSize = getTotalSize();
    const paddingTop = virtualRows.length > 0 ? ((_a = virtualRows == null ? void 0 : virtualRows[0]) == null ? void 0 : _a.start) || 0 : 0;
    const paddingBottom = virtualRows.length > 0 ? totalSize - (((_b = virtualRows == null ? void 0 : virtualRows[virtualRows.length - 1]) == null ? void 0 : _b.end) || 0) : 0;
    return /* @__PURE__ */ (0, import_jsx_runtime22.jsxs)("tbody", { children: [
      paddingTop > 0 && /* @__PURE__ */ (0, import_jsx_runtime22.jsx)("tr", { children: /* @__PURE__ */ (0, import_jsx_runtime22.jsx)("td", { sx: { height: `${paddingTop}px` } }) }),
      virtualRows.map((virtualRow) => {
        const row = rows[virtualRow.index];
        const disabled = !row.getCanSelect();
        return /* @__PURE__ */ (0, import_jsx_runtime22.jsxs)(import_react12.Fragment, { children: [
          /* @__PURE__ */ (0, import_jsx_runtime22.jsx)(
            TableRow,
            {
              disabled,
              cells: row.getVisibleCells().map((cell) => /* @__PURE__ */ (0, import_jsx_runtime22.jsx)(TableCell, { cell }, cell.id))
            }
          ),
          /* @__PURE__ */ (0, import_jsx_runtime22.jsx)(
            TableRowSubComponent,
            {
              visible: row.getIsExpanded(),
              colSpan: row.getVisibleCells().length,
              children: renderSubComponent && renderSubComponent({ row })
            }
          )
        ] }, row.id);
      }),
      paddingBottom > 0 && /* @__PURE__ */ (0, import_jsx_runtime22.jsx)("tr", { children: /* @__PURE__ */ (0, import_jsx_runtime22.jsx)("td", { sx: { height: `${paddingBottom}px` } }) })
    ] });
  }
  return /* @__PURE__ */ (0, import_jsx_runtime22.jsx)("tbody", { children: rows.map((row) => {
    const disabled = !row.getCanSelect();
    return /* @__PURE__ */ (0, import_jsx_runtime22.jsxs)(import_react12.Fragment, { children: [
      /* @__PURE__ */ (0, import_jsx_runtime22.jsx)(
        TableRow,
        {
          disabled,
          cells: row.getVisibleCells().map((cell) => /* @__PURE__ */ (0, import_jsx_runtime22.jsx)(TableCell, { cell }, cell.id))
        }
      ),
      /* @__PURE__ */ (0, import_jsx_runtime22.jsx)(
        TableRowSubComponent,
        {
          visible: row.getIsExpanded(),
          colSpan: row.getVisibleCells().length,
          children: renderSubComponent && renderSubComponent({ row })
        }
      )
    ] }, row.id);
  }) });
};

// src/table/table.fx.tsx
var import_jsx_runtime23 = require("theme-ui/jsx-runtime");
var withSelectColumn = (_a) => {
  var _b = _a, {
    columns,
    expandOnSelect
  } = _b, rest = __objRest(_b, [
    "columns",
    "expandOnSelect"
  ]);
  const select = {
    id: "select",
    size: 12,
    header: ({ table }) => !rest.singleSelect && /* @__PURE__ */ (0, import_jsx_runtime23.jsx)(
      Checkbox,
      __spreadValues({}, {
        checked: table.getIsAllRowsSelected(),
        indeterminate: table.getIsSomeRowsSelected(),
        onChange: (e) => {
          table.getToggleAllRowsSelectedHandler()(e);
          if (expandOnSelect) {
            table.getToggleAllRowsExpandedHandler()(e);
          }
        }
      })
    ),
    cell: ({ row }) => rest.singleSelect ? /* @__PURE__ */ (0, import_jsx_runtime23.jsx)(
      Radio,
      __spreadValues({
        name: rest.singleSelectGroupName
      }, {
        sx: {
          marginLeft: `${row.depth * 2}rem`,
          cursor: row.getCanSelect() ? "pointer" : "not-allowed"
        },
        checked: row.getIsSelected(),
        disabled: !row.getCanSelect(),
        onChange: (e) => {
          row.getToggleSelectedHandler()(e);
          if (expandOnSelect) {
            row.getToggleExpandedHandler()();
          }
        }
      })
    ) : /* @__PURE__ */ (0, import_jsx_runtime23.jsx)(
      Checkbox,
      __spreadValues({}, {
        sx: { marginLeft: `${row.depth * 2}rem` },
        checked: row.getIsSelected(),
        indeterminate: row.getIsSomeSelected(),
        disabled: !row.getCanSelect(),
        onChange: (e) => {
          row.getToggleSelectedHandler()(e);
          if (expandOnSelect) {
            row.getToggleExpandedHandler()();
          }
        }
      })
    )
  };
  return [select, ...columns];
};
var withExpandColumn = ({
  columns,
  expandOnSelect
}) => {
  if (expandOnSelect) {
    return [...columns];
  }
  const expand = {
    id: "expand",
    size: 12,
    maxSize: 42,
    header: ({ table }) => /* @__PURE__ */ (0, import_jsx_runtime23.jsx)(
      Button,
      __spreadValues({}, {
        onClick: table.getToggleAllRowsExpandedHandler(),
        icon: {
          name: table.getIsAllRowsExpanded() ? "expand_less" : "expand_more"
        },
        variant: "ghost"
      })
    ),
    cell: ({ row }) => row.getCanExpand() && /* @__PURE__ */ (0, import_jsx_runtime23.jsx)(
      Button,
      __spreadValues({}, {
        sx: { marginLeft: `${row.depth * 2}rem` },
        onClick: row.getToggleExpandedHandler(),
        icon: { name: row.getIsExpanded() ? "expand_less" : "expand_more" },
        variant: "ghost"
      })
    )
  };
  return [expand, ...columns];
};

// src/table/table.header.tsx
var import_react_table2 = require("@tanstack/react-table");
var import_jsx_runtime24 = require("theme-ui/jsx-runtime");
var TableHeader = ({ getHeaderGroups }) => {
  const darkMode = useIsDarkMode();
  return /* @__PURE__ */ (0, import_jsx_runtime24.jsx)(
    "thead",
    {
      sx: {
        backgroundColor: darkMode ? "b-600" : "b-200",
        position: "sticky",
        top: 0
      },
      children: getHeaderGroups().map((headerGroup) => /* @__PURE__ */ (0, import_jsx_runtime24.jsx)("tr", { children: headerGroup.headers.map((header) => /* @__PURE__ */ (0, import_jsx_runtime24.jsx)(
        "th",
        {
          colSpan: header.colSpan,
          sx: {
            width: header.getSize(),
            paddingY: "xs",
            paddingX: "md",
            textAlign: "left"
          },
          children: !header.isPlaceholder && (0, import_react_table2.flexRender)(header.column.columnDef.header, header.getContext())
        },
        header.id
      )) }, headerGroup.id))
    }
  );
};

// src/table/table.pagination.tsx
var import_theme_ui9 = require("theme-ui");
var import_jsx_runtime25 = require("theme-ui/jsx-runtime");
var TablePagination = (props) => {
  const {
    setPageIndex,
    getCanPreviousPage,
    previousPage,
    getState,
    getPageCount,
    nextPage,
    getCanNextPage
  } = props;
  return /* @__PURE__ */ (0, import_jsx_runtime25.jsxs)(import_theme_ui9.Flex, { sx: { marginY: "md", gap: "sm", justifyContent: "center" }, children: [
    /* @__PURE__ */ (0, import_jsx_runtime25.jsx)(
      Button,
      {
        onClick: () => setPageIndex(0),
        disabled: !getCanPreviousPage(),
        icon: { name: "first_page" }
      }
    ),
    /* @__PURE__ */ (0, import_jsx_runtime25.jsx)(
      Button,
      {
        onClick: () => previousPage(),
        disabled: !getCanPreviousPage(),
        icon: { name: "navigate_before" }
      }
    ),
    /* @__PURE__ */ (0, import_jsx_runtime25.jsx)(import_theme_ui9.Box, { sx: { width: "10rem", textAlign: "center" }, children: /* @__PURE__ */ (0, import_jsx_runtime25.jsxs)(Text, { children: [
      "Page",
      " ",
      /* @__PURE__ */ (0, import_jsx_runtime25.jsx)(Text, { as: "span", variant: "eyebrow", inline: true, children: getState().pagination.pageIndex + 1 }),
      " ",
      "of",
      " ",
      /* @__PURE__ */ (0, import_jsx_runtime25.jsx)(Text, { as: "span", variant: "eyebrow", inline: true, children: getPageCount() })
    ] }) }),
    /* @__PURE__ */ (0, import_jsx_runtime25.jsx)(
      Button,
      {
        onClick: () => nextPage(),
        disabled: !getCanNextPage(),
        icon: { name: "navigate_next" }
      }
    ),
    /* @__PURE__ */ (0, import_jsx_runtime25.jsx)(
      Button,
      {
        onClick: () => setPageIndex(getPageCount() - 1),
        disabled: !getCanNextPage(),
        icon: { name: "last_page" }
      }
    )
  ] });
};

// src/table/table.tsx
var import_jsx_runtime26 = require("theme-ui/jsx-runtime");
var Table2 = (_a) => {
  var _b = _a, {
    data,
    columns,
    pageSize,
    enableExpanding,
    enableSorting,
    enableFilters,
    enableRowSelection,
    expandOnSelect,
    renderSubComponent,
    onChange
  } = _b, rest = __objRest(_b, [
    "data",
    "columns",
    "pageSize",
    "enableExpanding",
    "enableSorting",
    "enableFilters",
    "enableRowSelection",
    "expandOnSelect",
    "renderSubComponent",
    "onChange"
  ]);
  if (pageSize && pageSize < 1) {
    throw new Error("Page size must be greater than or equal to 1");
  }
  const memoizedData = (0, import_react13.useMemo)(() => [...data], [data]);
  const memoizedColumns = (0, import_react13.useMemo)(() => {
    let modifiedColumns = columns;
    if (enableRowSelection) {
      modifiedColumns = withSelectColumn(__spreadValues({
        columns: modifiedColumns,
        expandOnSelect
      }, rest));
    }
    if (enableExpanding) {
      modifiedColumns = withExpandColumn({
        columns: modifiedColumns,
        expandOnSelect
      });
    }
    return modifiedColumns;
  }, [columns, expandOnSelect, enableExpanding, enableRowSelection, rest]);
  const table = (0, import_react_table3.useReactTable)({
    data: memoizedData,
    columns: memoizedColumns,
    enableRowSelection,
    enableMultiRowSelection: !rest.singleSelect,
    enableSorting,
    enableFilters,
    enableExpanding,
    getRowCanExpand: (row) => renderSubComponent ? !!renderSubComponent({ row }) : !!row.subRows.length,
    getIsRowExpanded: enableExpanding && expandOnSelect && enableRowSelection ? (row) => row.getIsSelected() : void 0,
    getSubRows: (row) => row.subRows,
    getCoreRowModel: (0, import_react_table3.getCoreRowModel)(),
    getPaginationRowModel: pageSize ? (0, import_react_table3.getPaginationRowModel)() : void 0,
    getFilteredRowModel: enableFilters ? (0, import_react_table3.getFilteredRowModel)() : void 0,
    getExpandedRowModel: enableExpanding ? (0, import_react_table3.getExpandedRowModel)() : void 0,
    getSortedRowModel: enableSorting ? (0, import_react_table3.getSortedRowModel)() : void 0
  });
  const { setPageSize } = table;
  const { rows } = table.getRowModel();
  const state = table.getState();
  const previousState = (0, import_utils.usePrevious)(state);
  (0, import_react13.useEffect)(() => {
    if (!onChange)
      return;
    if ((0, import_utils.isDeepEqual)(state, previousState))
      return;
    onChange(state);
  }, [state, previousState, onChange]);
  (0, import_react13.useEffect)(() => {
    if (pageSize) {
      setPageSize(pageSize);
    }
  }, [setPageSize, pageSize]);
  return /* @__PURE__ */ (0, import_jsx_runtime26.jsxs)(import_jsx_runtime26.Fragment, { children: [
    /* @__PURE__ */ (0, import_jsx_runtime26.jsxs)("table", { sx: { width: "100%", borderRadius: "xl", overflow: "clip" }, children: [
      /* @__PURE__ */ (0, import_jsx_runtime26.jsx)(TableHeader, __spreadValues({}, table)),
      /* @__PURE__ */ (0, import_jsx_runtime26.jsx)(TableBody, { rows, renderSubComponent })
    ] }),
    pageSize && /* @__PURE__ */ (0, import_jsx_runtime26.jsx)(TablePagination, __spreadValues({}, table))
  ] });
};
var VirtualizedTable = (_a) => {
  var _b = _a, {
    data,
    columns,
    pageSize,
    enableExpanding,
    enableSorting,
    enableFilters,
    enableRowSelection,
    expandOnSelect,
    renderSubComponent,
    onChange
  } = _b, rest = __objRest(_b, [
    "data",
    "columns",
    "pageSize",
    "enableExpanding",
    "enableSorting",
    "enableFilters",
    "enableRowSelection",
    "expandOnSelect",
    "renderSubComponent",
    "onChange"
  ]);
  if (pageSize && pageSize < 1) {
    throw new Error("Page size must be greater than or equal to 1");
  }
  const memoizedData = (0, import_react13.useMemo)(() => [...data], [data]);
  const memoizedColumns = (0, import_react13.useMemo)(() => {
    let modifiedColumns = columns;
    if (enableRowSelection) {
      modifiedColumns = withSelectColumn(__spreadValues({
        columns: modifiedColumns,
        expandOnSelect
      }, rest));
    }
    if (enableExpanding) {
      modifiedColumns = withExpandColumn({
        columns: modifiedColumns,
        expandOnSelect
      });
    }
    return modifiedColumns;
  }, [columns, expandOnSelect, enableExpanding, enableRowSelection, rest]);
  const table = (0, import_react_table3.useReactTable)({
    data: memoizedData,
    columns: memoizedColumns,
    enableRowSelection,
    enableMultiRowSelection: !rest.singleSelect,
    enableSorting,
    enableFilters,
    enableExpanding,
    getRowCanExpand: (row) => renderSubComponent ? !!renderSubComponent({ row }) : !!row.subRows.length,
    getIsRowExpanded: enableExpanding && expandOnSelect && enableRowSelection ? (row) => row.getIsSelected() : void 0,
    getSubRows: (row) => row.subRows,
    getCoreRowModel: (0, import_react_table3.getCoreRowModel)(),
    getPaginationRowModel: pageSize ? (0, import_react_table3.getPaginationRowModel)() : void 0,
    getFilteredRowModel: enableFilters ? (0, import_react_table3.getFilteredRowModel)() : void 0,
    getExpandedRowModel: enableExpanding ? (0, import_react_table3.getExpandedRowModel)() : void 0,
    getSortedRowModel: enableSorting ? (0, import_react_table3.getSortedRowModel)() : void 0
  });
  const { setPageSize } = table;
  const tableContainerRef = (0, import_react13.useRef)(null);
  const { rows } = table.getRowModel();
  const state = table.getState();
  const previousState = (0, import_utils.usePrevious)(state);
  const virtualizer = (0, import_react_virtual.useVirtualizer)({
    count: rows.length,
    getScrollElement: () => tableContainerRef.current,
    estimateSize: () => 34,
    overscan: 10
  });
  (0, import_react13.useEffect)(() => {
    if (pageSize) {
      setPageSize(pageSize);
    }
  }, [setPageSize, pageSize]);
  (0, import_react13.useEffect)(() => {
    if (!onChange)
      return;
    if ((0, import_utils.isDeepEqual)(state, previousState))
      return;
    onChange(state);
  }, [state, previousState, onChange]);
  const _a2 = rest, { singleSelect: _ } = _a2, styles = __objRest(_a2, ["singleSelect"]);
  return /* @__PURE__ */ (0, import_jsx_runtime26.jsx)(
    "div",
    {
      ref: tableContainerRef,
      sx: __spreadProps(__spreadValues({}, styles), { borderRadius: "xl", overflow: "auto" }),
      children: /* @__PURE__ */ (0, import_jsx_runtime26.jsxs)("table", { sx: { width: "100%", borderRadius: "xl", overflow: "clip" }, children: [
        /* @__PURE__ */ (0, import_jsx_runtime26.jsx)(TableHeader, __spreadValues({}, table)),
        /* @__PURE__ */ (0, import_jsx_runtime26.jsx)(
          TableBody,
          {
            rows,
            virtualizer,
            renderSubComponent
          }
        )
      ] })
    }
  );
};
Table2.Virtualized = VirtualizedTable;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  Anchor,
  Button,
  ButtonGroup,
  Card,
  CardButton,
  Checkbox,
  Code,
  CodeBlock,
  Icon,
  InputContainer,
  Label,
  Overlay,
  Radio,
  Spinner,
  SpinnerContext,
  SpinnerProvider,
  Table,
  Text,
  VirtualizedTable,
  useIsDarkMode,
  useSpinner,
  useSpinnerContext,
  withSpinner
});
