var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};

// src/anchor/anchor.tsx
import {
  forwardRef
} from "react";

// src/icon/icon.fx.ts
var getIconClassName = (variant, className) => {
  const trimmed = variant == null ? void 0 : variant.trim();
  return trimmed === "filled" ? `material-icons ${className || ""}`.trimEnd() : `material-icons-${trimmed} ${className || ""}`.trimEnd();
};

// src/icon/icon.styles.ts
import { Size } from "@waystone/core";
var IconSize = /* @__PURE__ */ ((IconSize2) => {
  IconSize2["sm"] = "1em";
  IconSize2["md"] = "1.5em";
  IconSize2["lg"] = "2em";
  return IconSize2;
})(IconSize || {});
var convert = (size) => IconSize[Size[size]];
var iconCss = (props) => {
  const css = {
    verticalAlign: "middle",
    color: props.color || "inherit",
    fontSize: "inherit"
  };
  if (props.size) {
    css.fontSize = `${convert(props.size)} !important`;
  }
  return css;
};

// src/icon/icon.tsx
import { jsx } from "theme-ui/jsx-runtime";
var Icon = (_a) => {
  var _b = _a, {
    className,
    name,
    variant = "filled",
    size = "md",
    color = "inherit"
  } = _b, rest = __objRest(_b, [
    "className",
    "name",
    "variant",
    "size",
    "color"
  ]);
  return /* @__PURE__ */ jsx(
    "i",
    __spreadProps(__spreadValues({
      sx: iconCss({ size, color }),
      className: getIconClassName(variant, className)
    }, rest), {
      children: name
    })
  );
};

// src/anchor/anchor.styles.tsx
import { getOutlineCss } from "@waystone/core";
var outline = getOutlineCss();
var anchorCss = __spreadProps(__spreadValues({
  paddingX: "xs",
  textDecoration: "none",
  borderBottom: "1px solid",
  borderBottomColor: "highlight",
  color: "inherit",
  transition: "all 100ms",
  fontFamily: "inherit",
  fontWeight: "inherit",
  fontSize: "inherit",
  cursor: "pointer"
}, outline.base), {
  ":hover": {
    backgroundColor: "ghost",
    borderTopLeftRadius: "sm",
    borderTopRightRadius: "sm"
  },
  ":focus-visible": __spreadValues({
    backgroundColor: "ghost",
    borderTopLeftRadius: "sm",
    borderTopRightRadius: "sm"
  }, outline.focused[":enabled:not(active):focus-visible"])
});
var undecoratedAnchorCss = {
  display: "flex",
  justifyContent: "center",
  alignItems: "center",
  cursor: "pointer"
};

// src/anchor/anchor.tsx
import { jsx as jsx2, jsxs } from "theme-ui/jsx-runtime";
var renderInternalAnchor = (_a, ref) => {
  var _b = _a, {
    children,
    noDecoration
  } = _b, rest = __objRest(_b, [
    "children",
    "noDecoration"
  ]);
  return /* @__PURE__ */ jsx2("a", __spreadProps(__spreadValues({ ref }, rest), { sx: noDecoration ? undecoratedAnchorCss : anchorCss, children }));
};
var InternalAnchor = forwardRef(renderInternalAnchor);
var renderExternalAnchor = (_a, ref) => {
  var _b = _a, {
    children,
    noDecoration,
    target = "_blank",
    rel = "noopener noreferrer"
  } = _b, rest = __objRest(_b, [
    "children",
    "noDecoration",
    "target",
    "rel"
  ]);
  return /* @__PURE__ */ jsxs(
    "a",
    __spreadProps(__spreadValues({
      ref
    }, rest), {
      sx: !noDecoration ? anchorCss : undecoratedAnchorCss,
      target,
      rel,
      children: [
        children,
        " ",
        /* @__PURE__ */ jsx2(Icon, { name: "open_in_new", size: "sm", sx: { pb: "xs" } })
      ]
    })
  );
};
var ExternalAnchor = forwardRef(renderExternalAnchor);
var renderAnchor = (_a, ref) => {
  var _b = _a, { external = false } = _b, rest = __objRest(_b, ["external"]);
  if (external) {
    return /* @__PURE__ */ jsx2(ExternalAnchor, __spreadValues({ ref }, rest));
  }
  return /* @__PURE__ */ jsx2(InternalAnchor, __spreadValues({ ref }, rest));
};
var Anchor = forwardRef(renderAnchor);

// src/button/button.tsx
import { useMemo } from "react";
import {
  Flex,
  Button as ThemeUiButton
} from "theme-ui";

// src/hooks/useIsDarkMode.tsx
import { useColorMode } from "theme-ui";
var useIsDarkMode = () => {
  const [colorMode] = useColorMode();
  const darkMode = colorMode === "dark";
  return darkMode;
};

// src/overlay/overlay.tsx
import { alpha } from "@theme-ui/color";
import { jsx as jsx3 } from "theme-ui/jsx-runtime";
var Overlay = ({ children, fullScreen = false }) => /* @__PURE__ */ jsx3(
  "div",
  {
    sx: {
      position: fullScreen ? "fixed" : "absolute",
      top: 0,
      left: 0,
      width: "100%",
      height: "100%",
      zIndex: "highest",
      bg: alpha("muted", 0.9),
      backdropFilter: "blur(10px)"
    },
    children: /* @__PURE__ */ jsx3("div", { sx: { opacity: 1 }, children })
  }
);

// src/spinner/spinner.styles.ts
import { keyframes } from "@emotion/react";
var changeContent = keyframes`
10% { content: "⠙"; }
20% { content: "⠹"; }
30% { content: "⠸"; }
40% { content: "⠼"; }
50% { content: "⠴"; }
60% { content: "⠦"; }
70% { content: "⠧"; }
80% { content: "⠇"; }
90% { content: "⠏"; }
`;
var getSpinnerSize = (size) => {
  switch (size) {
    case "sm":
      return "1.3125rem";
    case "md":
      return "1.5em";
    case "lg":
      return "2em";
    default:
      return "1.5em";
  }
};
var spinnerCss = ({
  size,
  color,
  fullWidth
}) => {
  const css = {
    color,
    display: fullWidth ? "flex" : "inline-flex",
    width: fullWidth ? "100%" : "auto",
    height: getSpinnerSize(size || "md"),
    alignItems: "center",
    justifyContent: "center",
    aspectRatio: "1",
    ":after": {
      animation: `${changeContent} 600ms linear infinite`,
      display: "block",
      content: '"\u280B"',
      fontSize: getSpinnerSize(size || "md")
    }
  };
  return css;
};

// src/spinner/spinner.tsx
import { jsx as jsx4 } from "theme-ui/jsx-runtime";
var Spinner = ({
  size = "md",
  color = "accent",
  fullWidth = false,
  overlay = false
}) => {
  if (overlay) {
    return /* @__PURE__ */ jsx4(Overlay, { children: /* @__PURE__ */ jsx4(
      "span",
      {
        sx: __spreadProps(__spreadValues({}, spinnerCss({ size, color, fullWidth: true })), {
          height: "100%",
          zIndex: "highest",
          position: "absolute"
        })
      }
    ) });
  }
  return /* @__PURE__ */ jsx4(
    "span",
    {
      role: "progressbar",
      sx: spinnerCss({ size, color, fullWidth }),
      "aria-valuetext": "Loading...",
      "aria-busy": true
    }
  );
};

// src/spinner/spinner.hoc.tsx
import { jsx as jsx5 } from "theme-ui/jsx-runtime";
function withSpinner(WrappedComponent) {
  const ComponentWithSpinner = (props) => {
    const { loading } = props;
    return loading ? /* @__PURE__ */ jsx5(Spinner, __spreadValues({}, props)) : /* @__PURE__ */ jsx5(WrappedComponent, __spreadValues({}, props));
  };
  return ComponentWithSpinner;
}

// src/spinner/spinner.hooks.tsx
import React from "react";
import { jsx as jsx6 } from "theme-ui/jsx-runtime";
var useSpinner = (props) => {
  var _a, _b;
  const [visible, setVisible] = React.useState((_a = props == null ? void 0 : props.initialVisible) != null ? _a : false);
  const show = () => setVisible(true);
  const hide = () => setVisible(false);
  const spinner = visible && /* @__PURE__ */ jsx6(Spinner, { overlay: (_b = props == null ? void 0 : props.overlay) != null ? _b : true });
  return { show, hide, spinner };
};

// src/spinner/spinner.context.tsx
import React2 from "react";
import { jsxs as jsxs2 } from "theme-ui/jsx-runtime";
var SpinnerContext = React2.createContext({});
var SpinnerProvider = ({ initialVisible = true, children }) => {
  const { show, hide, spinner } = useSpinner({ initialVisible });
  const value = React2.useMemo(() => ({ show, hide }), [show, hide]);
  return /* @__PURE__ */ jsxs2(SpinnerContext.Provider, { value, children: [
    children,
    spinner
  ] });
};
var useSpinnerContext = () => {
  const context = React2.useContext(SpinnerContext);
  if (!context) {
    throw new Error(
      '"useSpinnerContext" must be used within a "SpinnerProvider"'
    );
  }
  return context;
};

// src/text/text.tsx
import { Text as ThemeUiText } from "theme-ui";

// src/text/text.styles.ts
var textCss = ({
  inline,
  variant,
  color
}) => {
  const css = {
    display: "block",
    variant: `text.${variant}`,
    color: color || "inherit"
  };
  if (inline) {
    css.display = "inline-block";
    css.marginY = 0;
    css.marginX = 0;
  }
  return css;
};

// src/text/text.tsx
import { jsx as jsx7 } from "theme-ui/jsx-runtime";
var Text = (_a) => {
  var _b = _a, {
    children,
    as = "span",
    inline = false,
    variant = "body",
    color
  } = _b, rest = __objRest(_b, [
    "children",
    "as",
    "inline",
    "variant",
    "color"
  ]);
  return /* @__PURE__ */ jsx7(ThemeUiText, __spreadProps(__spreadValues({ sx: textCss({ inline, variant, color }), as }, rest), { children }));
};

// src/button/button.fx.ts
var getTextVariant = (size) => {
  switch (size) {
    case "sm":
      return "caption";
    case "lg":
      return "eyebrow";
    default:
      return "body";
  }
};

// src/button/button.styles.ts
import { getOutlineCss as getOutlineCss2 } from "@waystone/core";

// src/button/button.styles.fx.ts
import { addDarkModeSuffix } from "@waystone/core";
var getBackgroundColor = ({
  variant = "primary"
}) => {
  switch (variant) {
    case "ghost":
      return "ghost";
    case "link":
      return "transparent";
    case "primary":
    case "secondary":
    case "accent":
    case "highlight":
    default:
      return `${variant[0]}-400`;
  }
};
var getHoverBackgroundColor = ({
  variant = "primary",
  darkMode
}) => {
  switch (variant) {
    case "ghost":
      return darkMode ? "b-700" : "b-200";
    case "link":
      return "transparent";
    case "primary":
    case "secondary":
    case "accent":
    case "highlight":
    default:
      return `${variant[0]}-300`;
  }
};
var getActiveBackgroundColor = ({
  variant = "primary",
  darkMode
}) => {
  switch (variant) {
    case "ghost":
      return darkMode ? "b-700" : "b-200";
    case "link":
      return "transparent";
    case "primary":
    case "secondary":
    case "accent":
    case "highlight":
    default:
      return `${variant[0]}-300`;
  }
};
var getColor = (variant) => {
  switch (variant) {
    case "primary":
    case "secondary":
    case "accent":
    case "highlight":
      return "b-900";
    default:
      return "text";
  }
};
var getLinkVariantActiveColor = (darkMode) => darkMode ? "h-400" : "h-700";
var getLinkVariantHoverColor = (darkMode) => darkMode ? "h-400" : "h-700";
var getBoxShadow = ({
  variant = "primary",
  darkMode
}) => {
  if (["ghost", "link"].includes(variant)) {
    return {
      normalBoxShadow: "none",
      hoverBoxShadow: "none",
      activeBoxShadow: "none"
    };
  }
  return {
    normalBoxShadow: addDarkModeSuffix("sm", darkMode),
    hoverBoxShadow: addDarkModeSuffix("md", darkMode),
    activeBoxShadow: addDarkModeSuffix("sm", darkMode)
  };
};
var getPadding = ({
  variant = "primary",
  size
}) => {
  if (variant === "link")
    return { paddingX: 0, paddingY: 0 };
  switch (size) {
    case "sm": {
      return {
        paddingX: "sm",
        paddingY: "xs"
      };
    }
    case "lg": {
      return {
        paddingX: "xl",
        paddingY: "sm"
      };
    }
    default:
      return {
        paddingX: "md",
        paddingY: "sm"
      };
  }
};

// src/button/button.styles.ts
var buttonCss = ({
  variant,
  size,
  darkMode,
  width,
  minWidth,
  maxWidth,
  fullWidth,
  active
}) => {
  const { normalBoxShadow, hoverBoxShadow, activeBoxShadow } = getBoxShadow({
    variant,
    darkMode
  });
  const { paddingX, paddingY } = getPadding({ variant, size });
  const color = getColor(variant);
  const outline3 = getOutlineCss2();
  const isLink = variant === "link";
  const hoverCss = {
    color: isLink ? getLinkVariantHoverColor(darkMode) : color,
    boxShadow: hoverBoxShadow,
    backgroundColor: getHoverBackgroundColor({ variant, darkMode })
  };
  const focusCss = {
    color: isLink ? getLinkVariantActiveColor(darkMode) : color,
    boxShadow: activeBoxShadow,
    backgroundColor: getActiveBackgroundColor({ variant, darkMode })
  };
  const activeCss = {
    color: isLink ? getLinkVariantActiveColor(darkMode) : color,
    boxShadow: activeBoxShadow,
    backgroundColor: getActiveBackgroundColor({ variant, darkMode })
  };
  const baseCss = __spreadProps(__spreadValues({
    display: "flex",
    flexWrap: "nowrap",
    alignItems: "center",
    justifyContent: "center",
    color,
    backgroundColor: getBackgroundColor({ variant, darkMode }),
    paddingX,
    paddingY,
    width: fullWidth ? "100%" : width,
    maxWidth: !fullWidth && maxWidth,
    minWidth: !fullWidth && minWidth,
    boxShadow: normalBoxShadow,
    margin: 0,
    cursor: "pointer",
    transition: "all 200ms ease"
  }, outline3.base), {
    ":enabled:hover": __spreadValues({}, hoverCss),
    ":not(active):focus-visible": __spreadValues(__spreadValues({}, focusCss), outline3.focused[":enabled:not(active):focus-visible"]),
    ":enabled:active": __spreadValues(__spreadValues({}, activeCss), outline3.active[":enabled:active"]),
    ":disabled": {
      color: "b-400",
      backgroundColor: !isLink && "muted",
      cursor: "not-allowed"
    }
  });
  if (active) {
    return __spreadValues(__spreadValues({}, baseCss), activeCss);
  }
  return baseCss;
};
var buttonAddonCss = ({
  hasChildren,
  variant,
  size
}) => ({
  marginRight: hasChildren && "sm",
  marginY: getPadding({ variant, size })
});

// src/button/button.tsx
import { jsx as jsx8, jsxs as jsxs3 } from "theme-ui/jsx-runtime";
var Button = (_a) => {
  var _b = _a, {
    children,
    icon,
    width,
    minWidth,
    maxWidth,
    fullWidth,
    variant = "primary",
    size = "sm",
    hideContentWhileLoading = false,
    loading = false,
    disabled = false,
    active = false
  } = _b, rest = __objRest(_b, [
    "children",
    "icon",
    "width",
    "minWidth",
    "maxWidth",
    "fullWidth",
    "variant",
    "size",
    "hideContentWhileLoading",
    "loading",
    "disabled",
    "active"
  ]);
  const isDarkMode = useIsDarkMode();
  const shouldBeDisabled = disabled || loading;
  const shouldRenderChildren = !!children && (!loading || !hideContentWhileLoading);
  const shouldRenderIcon = !loading && icon;
  const buttonSx = useMemo(() => {
    const buttonCssParams = {
      variant,
      size,
      darkMode: isDarkMode,
      active,
      width,
      minWidth,
      maxWidth,
      fullWidth
    };
    return buttonCss(buttonCssParams);
  }, [variant, size, isDarkMode, active, width, minWidth, maxWidth, fullWidth]);
  const buttonAddonSx = useMemo(() => {
    const buttonAddonCssParams = {
      variant,
      size,
      hasChildren: shouldRenderChildren
    };
    return buttonAddonCss(buttonAddonCssParams);
  }, [variant, size, shouldRenderChildren]);
  const spinnerSize = size === "sm" ? "sm" : "md";
  return /* @__PURE__ */ jsxs3(ThemeUiButton, __spreadProps(__spreadValues({ sx: buttonSx, disabled: shouldBeDisabled }, rest), { children: [
    loading && /* @__PURE__ */ jsx8(Flex, { sx: buttonAddonSx, children: /* @__PURE__ */ jsx8(Spinner, { size: spinnerSize }) }),
    shouldRenderIcon && /* @__PURE__ */ jsx8(Flex, { sx: buttonAddonSx, children: /* @__PURE__ */ jsx8(Icon, __spreadValues({ size: "sm" }, icon)) }),
    shouldRenderChildren && /* @__PURE__ */ jsx8(Text, { variant: getTextVariant(size), inline: true, children })
  ] }));
};

// src/button-group/buttonGroup.tsx
import { Flex as Flex2 } from "theme-ui";

// src/button-group/buttonGroup.styles.ts
var buttonGroupCss = {
  gap: "xs",
  padding: "xs",
  borderRadius: "sm",
  backgroundColor: "ghost",
  width: "fit-content"
};

// src/button-group/buttonGroup.tsx
import { jsx as jsx9 } from "theme-ui/jsx-runtime";
import { createElement } from "theme-ui";
var ButtonGroup = ({
  activeButton,
  buttons,
  onChange,
  size
}) => /* @__PURE__ */ jsx9(Flex2, { sx: buttonGroupCss, children: buttons.map((button) => {
  if (!button.id) {
    throw new Error("You must provide an `id` for each button");
  }
  const key = button.id;
  return /* @__PURE__ */ createElement(
    Button,
    __spreadProps(__spreadValues({}, button), {
      key,
      size,
      variant: "ghost",
      active: key === activeButton,
      onClick: (e) => {
        if (onChange)
          onChange({ e, clicked: key });
      }
    })
  );
}) });

// src/card/card.tsx
import { useColorMode as useColorMode2 } from "theme-ui";

// src/card/card.styles.ts
var cardContainerCss = (_a) => {
  var _b = _a, {
    fullWidth,
    width,
    minWidth,
    maxWidth,
    noShadow,
    darkMode
  } = _b, rest = __objRest(_b, [
    "fullWidth",
    "width",
    "minWidth",
    "maxWidth",
    "noShadow",
    "darkMode"
  ]);
  return __spreadValues({
    borderRadius: "md",
    width: fullWidth ? "100%" : width || "auto",
    minWidth: !fullWidth && minWidth,
    maxWidth: !fullWidth && maxWidth,
    backgroundColor: darkMode ? "b-600" : "b-50",
    boxShadow: !noShadow && "md",
    overflowY: "auto"
  }, rest);
};
var coverImageCss = ({
  url,
  size = "cover",
  repeat = "no-repeat",
  position = "center",
  height = "md",
  fallbackColor = "secondary"
}) => ({
  backgroundImage: `url(${url})`,
  backgroundColor: fallbackColor,
  backgroundSize: size,
  backgroundRepeat: repeat,
  backgroundPosition: position,
  width: "100%",
  height
});
var cardContentCss = (noPadding) => ({
  padding: noPadding ? 0 : "md"
});

// src/card/card.tsx
import { jsx as jsx10, jsxs as jsxs4 } from "theme-ui/jsx-runtime";
var Card = (_a) => {
  var _b = _a, {
    children,
    coverImage,
    noPadding
  } = _b, rest = __objRest(_b, [
    "children",
    "coverImage",
    "noPadding"
  ]);
  const [mode] = useColorMode2();
  const darkMode = mode === "dark";
  return /* @__PURE__ */ jsxs4(
    "div",
    {
      sx: cardContainerCss(__spreadProps(__spreadValues({}, rest), {
        darkMode
      })),
      children: [
        coverImage && /* @__PURE__ */ jsx10("div", { sx: coverImageCss(coverImage), role: "img" }),
        /* @__PURE__ */ jsx10("div", { sx: cardContentCss(noPadding), children })
      ]
    }
  );
};

// src/card-button/cardButton.tsx
import { getOutlineCss as getOutlineCss3 } from "@waystone/core";
import { jsx as jsx11, jsxs as jsxs5 } from "theme-ui/jsx-runtime";
var CardButton = (_a) => {
  var _b = _a, {
    children,
    fullWidth,
    width,
    minWidth,
    maxWidth,
    noShadow,
    disabled,
    loading,
    onClick
  } = _b, rest = __objRest(_b, [
    "children",
    "fullWidth",
    "width",
    "minWidth",
    "maxWidth",
    "noShadow",
    "disabled",
    "loading",
    "onClick"
  ]);
  const darkMode = useIsDarkMode();
  const outline3 = getOutlineCss3();
  const cardCss = __spreadProps(__spreadValues(__spreadValues(__spreadValues({
    position: "relative",
    paddingX: "md",
    paddingY: "md",
    border: "none",
    borderRadius: "md",
    color: "text",
    width: fullWidth ? "100%" : width || "auto",
    minWidth: !fullWidth && minWidth,
    maxWidth: !fullWidth && maxWidth,
    backgroundColor: darkMode ? "b-600" : "b-50",
    boxShadow: !noShadow && "md",
    cursor: "pointer",
    overflow: "hidden",
    textAlign: "left",
    transition: "all 200ms"
  }, outline3.base), outline3.focused), rest), {
    ":enabled:hover": {
      backgroundColor: darkMode ? "b-500" : "b-100"
    },
    ":enabled:active": __spreadValues({
      backgroundColor: darkMode ? "b-400" : "b-200"
    }, outline3.active[":enabled:active"]),
    ":disabled": {
      color: "b-400",
      backgroundColor: "muted",
      cursor: "not-allowed"
    }
  });
  return /* @__PURE__ */ jsxs5(
    "button",
    {
      sx: cardCss,
      onClick,
      type: "button",
      disabled: disabled || loading,
      children: [
        loading && /* @__PURE__ */ jsx11(Spinner, { overlay: true }),
        children
      ]
    }
  );
};

// src/code/code.tsx
import { useColorMode as useColorMode3 } from "theme-ui";

// src/code/code.styles.ts
var codeCss = (darkMode) => ({
  variant: "text.mono",
  fontSize: "caption",
  backgroundColor: darkMode ? "b-600" : "b-200",
  borderRadius: "sm",
  px: "xs",
  py: 2,
  color: darkMode ? "highlight" : "b-600"
});

// src/code/code.tsx
import { jsx as jsx12 } from "theme-ui/jsx-runtime";
var Code = ({ children }) => {
  const [mode] = useColorMode3();
  return /* @__PURE__ */ jsx12("code", { sx: codeCss(mode === "dark"), children });
};

// src/code-block/codeBlock.tsx
import {
  SyntaxHighlighter
} from "@waystone/syntax-highlighter";
import { useState } from "react";

// src/code-block/codeBlock.fx.ts
var copy = (text) => {
  navigator.clipboard.writeText(text);
};

// src/code-block/codeBlock.styles.ts
import { getOutlineCss as getOutlineCss4 } from "@waystone/core";
var codeBlockContainerCss = {
  backgroundColor: "b-600",
  mb: "lg",
  mx: "md",
  borderRadius: "md",
  variant: "text.monospace",
  display: "block",
  position: "relative",
  overflow: "clip"
};
var codeBlockLanguageCss = {
  variant: "text.small",
  letterSpacing: 1.25,
  fontWeight: "medium",
  position: "absolute",
  top: 0,
  left: "1.5rem",
  backgroundColor: "a-600",
  padding: "xs",
  color: "b-50",
  textTransform: "uppercase",
  boxShadow: "sm-dark",
  borderBottomLeftRadius: "sm",
  borderBottomRightRadius: "sm",
  pointerEvents: "none"
};
var outline2 = getOutlineCss4();
var codeBlockCopyButtonCss = __spreadProps(__spreadValues(__spreadValues({
  variant: "text.small",
  letterSpacing: 1.25,
  fontWeight: "medium",
  position: "absolute",
  top: 0,
  right: "1.5rem",
  padding: "xs",
  background: "b-500",
  boxShadow: "sm-dark",
  border: "none",
  borderBottomLeftRadius: "sm",
  borderBottomRightRadius: "sm",
  color: "b-50",
  textTransform: "uppercase",
  cursor: "pointer",
  transition: "all 200ms"
}, outline2.base), outline2.focused), {
  ":hover": {
    background: "b-400"
  },
  ":active": __spreadValues({
    background: "b-300"
  }, outline2.active[":enabled:active"])
});
var codeBlockCaptionCss = {
  position: "absolute",
  variant: "text.caption",
  textAlign: "center",
  bottom: 0,
  left: 0,
  right: 0,
  padding: "xs",
  backgroundColor: "b-700",
  color: "b-50"
};

// src/code-block/codeBlock.tsx
import { jsx as jsx13, jsxs as jsxs6 } from "theme-ui/jsx-runtime";
var CodeBlock = ({
  language,
  wordWrap = false,
  caption,
  children,
  styleName = "tomorrowNightBlue"
}) => {
  const [iconName, setIconName] = useState("content_copy");
  const handleCopy = () => {
    copy(children);
    setIconName("done");
  };
  const handleBlur = () => {
    setIconName("content_copy");
  };
  return /* @__PURE__ */ jsxs6("div", { sx: codeBlockContainerCss, children: [
    language && /* @__PURE__ */ jsx13("div", { sx: codeBlockLanguageCss, children: language }),
    /* @__PURE__ */ jsx13(
      "button",
      {
        sx: codeBlockCopyButtonCss,
        type: "button",
        onClick: handleCopy,
        onBlur: handleBlur,
        children: /* @__PURE__ */ jsx13(Icon, { name: iconName })
      }
    ),
    /* @__PURE__ */ jsx13(
      SyntaxHighlighter,
      {
        wrapLines: wordWrap,
        language,
        styleName,
        children
      }
    ),
    caption && /* @__PURE__ */ jsx13("div", { sx: codeBlockCaptionCss, children: caption })
  ] });
};

// src/forms/inputs/checkbox/checkbox.tsx
import { useEffect, useRef } from "react";
import { jsx as jsx14 } from "theme-ui/jsx-runtime";
var Checkbox = (_a) => {
  var _b = _a, {
    indeterminate,
    checked
  } = _b, rest = __objRest(_b, [
    "indeterminate",
    "checked"
  ]);
  const ref = useRef(null);
  useEffect(() => {
    if (ref.current) {
      ref.current.indeterminate = !!indeterminate;
    }
  }, [ref, checked, indeterminate]);
  return /* @__PURE__ */ jsx14(
    "input",
    __spreadValues({
      sx: {
        cursor: rest.disabled ? "not-allowed" : "pointer"
      },
      type: "checkbox",
      ref,
      checked
    }, rest)
  );
};

// src/forms/inputs/container/inputContainer.tsx
import { Flex as Flex3 } from "theme-ui";

// src/label/label.tsx
import { jsx as jsx15 } from "theme-ui/jsx-runtime";
var Label = ({ htmlFor, children }) => {
  const darkMode = useIsDarkMode();
  const labelCss2 = {
    textTransform: "capitalize",
    color: darkMode ? "b-300" : "b-500",
    fontWeight: "medium",
    fontSize: "caption",
    letterSpacing: "0.1em"
  };
  return /* @__PURE__ */ jsx15("label", { sx: labelCss2, htmlFor, children });
};

// src/forms/inputs/container/inputContainer.fx.ts
var getIconName = (variant) => {
  switch (variant) {
    case "success":
      return "check_circle";
    case "error":
      return "error";
    case "warning":
      return "warning";
    default:
      return "info";
  }
};
var getVariantColor = (variant) => variant ? `${variant}-400` : "b-400";

// src/forms/inputs/container/inputContainer.styles.ts
var inputContainerCss = ({
  width,
  minWidth,
  maxWidth
}) => {
  const baseCss = {
    flexDirection: "column"
  };
  return __spreadProps(__spreadValues({}, baseCss), { width, minWidth, maxWidth });
};
var labelContainerCss = {
  justifyContent: "space-between",
  alignItems: "baseline",
  marginBottom: "xs"
};
var labelCss = {
  alignItems: "center",
  gap: "xs"
};

// src/forms/inputs/container/inputContainer.tsx
import { jsx as jsx16, jsxs as jsxs7 } from "theme-ui/jsx-runtime";
var InputContainer = (_a) => {
  var _b = _a, {
    id,
    label,
    children,
    helpText,
    variant,
    required
  } = _b, rest = __objRest(_b, [
    "id",
    "label",
    "children",
    "helpText",
    "variant",
    "required"
  ]);
  const color = getVariantColor(variant);
  return /* @__PURE__ */ jsxs7(Flex3, { sx: inputContainerCss(__spreadValues({}, rest)), children: [
    /* @__PURE__ */ jsxs7(Flex3, { sx: labelContainerCss, children: [
      /* @__PURE__ */ jsxs7(Flex3, { sx: labelCss, children: [
        /* @__PURE__ */ jsx16(Label, { htmlFor: id, children: label }),
        variant && /* @__PURE__ */ jsx16(Icon, { color, name: getIconName(variant), size: "sm" })
      ] }),
      required && /* @__PURE__ */ jsx16(Text, { variant: "small", color: "error-400", inline: true, children: "required" })
    ] }),
    children,
    helpText && /* @__PURE__ */ jsx16(Text, { variant: "small", color, inline: true, children: helpText })
  ] });
};

// src/forms/inputs/radio/radio.tsx
import { forwardRef as forwardRef2 } from "react";
import { jsx as jsx17 } from "theme-ui/jsx-runtime";
var Radio = forwardRef2((props, ref) => /* @__PURE__ */ jsx17("input", __spreadValues({ ref, type: "radio" }, props)));
Radio.displayName = "Radio";

// src/table/table.tsx
import {
  getCoreRowModel,
  getExpandedRowModel,
  getFilteredRowModel,
  getPaginationRowModel,
  getSortedRowModel,
  useReactTable
} from "@tanstack/react-table";
import { useVirtualizer } from "@tanstack/react-virtual";
import { isDeepEqual, usePrevious } from "@waystone/utils";
import { useEffect as useEffect2, useMemo as useMemo4, useRef as useRef2 } from "react";

// src/table/table.body.tsx
import { Fragment } from "react";

// src/table/table.cell.tsx
import { flexRender } from "@tanstack/react-table";
import { useMemo as useMemo2 } from "react";
import { jsx as jsx18 } from "theme-ui/jsx-runtime";
var TableCell = ({
  cell
}) => {
  const size = useMemo2(() => cell.column.getSize(), [cell.column]);
  return /* @__PURE__ */ jsx18(
    "td",
    {
      sx: {
        minWidth: size,
        maxWidth: size,
        paddingY: "xs",
        paddingX: "md"
      },
      children: flexRender(cell.column.columnDef.cell, cell.getContext())
    }
  );
};

// src/table/table.row.tsx
import { memo, useMemo as useMemo3 } from "react";
import { jsx as jsx19 } from "theme-ui/jsx-runtime";
var getBackgroundColor2 = (darkMode, disabled) => {
  if (darkMode) {
    return disabled ? "b-600" : "b-700";
  }
  return disabled ? "b-200" : "b-100";
};
var TableRowContent = ({ disabled = false, cells }) => {
  const darkMode = useIsDarkMode();
  const backgroundColor = useMemo3(
    () => getBackgroundColor2(darkMode, disabled),
    [darkMode, disabled]
  );
  return /* @__PURE__ */ jsx19(
    "tr",
    {
      sx: {
        backgroundColor,
        color: disabled ? "b-400" : "text"
      },
      children: cells
    }
  );
};
var TableRow = memo(TableRowContent);

// src/table/table.row.subComponent.tsx
import { memo as memo2 } from "react";
import { jsx as jsx20 } from "theme-ui/jsx-runtime";
var TableRowSubComponentContent = ({
  colSpan,
  visible,
  children
}) => {
  if (!visible || !children) {
    return null;
  }
  return /* @__PURE__ */ jsx20("tr", { children: /* @__PURE__ */ jsx20("td", { sx: { padding: "xs" }, colSpan, children }) });
};
var TableRowSubComponent = memo2(TableRowSubComponentContent);

// src/table/table.body.tsx
import { jsx as jsx21, jsxs as jsxs8 } from "theme-ui/jsx-runtime";
var TableBody = ({
  renderSubComponent,
  rows,
  virtualizer
}) => {
  var _a, _b;
  if (virtualizer) {
    const { getTotalSize, getVirtualItems } = virtualizer;
    const virtualRows = getVirtualItems();
    const totalSize = getTotalSize();
    const paddingTop = virtualRows.length > 0 ? ((_a = virtualRows == null ? void 0 : virtualRows[0]) == null ? void 0 : _a.start) || 0 : 0;
    const paddingBottom = virtualRows.length > 0 ? totalSize - (((_b = virtualRows == null ? void 0 : virtualRows[virtualRows.length - 1]) == null ? void 0 : _b.end) || 0) : 0;
    return /* @__PURE__ */ jsxs8("tbody", { children: [
      paddingTop > 0 && /* @__PURE__ */ jsx21("tr", { children: /* @__PURE__ */ jsx21("td", { sx: { height: `${paddingTop}px` } }) }),
      virtualRows.map((virtualRow) => {
        const row = rows[virtualRow.index];
        const disabled = !row.getCanSelect();
        return /* @__PURE__ */ jsxs8(Fragment, { children: [
          /* @__PURE__ */ jsx21(
            TableRow,
            {
              disabled,
              cells: row.getVisibleCells().map((cell) => /* @__PURE__ */ jsx21(TableCell, { cell }, cell.id))
            }
          ),
          /* @__PURE__ */ jsx21(
            TableRowSubComponent,
            {
              visible: row.getIsExpanded(),
              colSpan: row.getVisibleCells().length,
              children: renderSubComponent && renderSubComponent({ row })
            }
          )
        ] }, row.id);
      }),
      paddingBottom > 0 && /* @__PURE__ */ jsx21("tr", { children: /* @__PURE__ */ jsx21("td", { sx: { height: `${paddingBottom}px` } }) })
    ] });
  }
  return /* @__PURE__ */ jsx21("tbody", { children: rows.map((row) => {
    const disabled = !row.getCanSelect();
    return /* @__PURE__ */ jsxs8(Fragment, { children: [
      /* @__PURE__ */ jsx21(
        TableRow,
        {
          disabled,
          cells: row.getVisibleCells().map((cell) => /* @__PURE__ */ jsx21(TableCell, { cell }, cell.id))
        }
      ),
      /* @__PURE__ */ jsx21(
        TableRowSubComponent,
        {
          visible: row.getIsExpanded(),
          colSpan: row.getVisibleCells().length,
          children: renderSubComponent && renderSubComponent({ row })
        }
      )
    ] }, row.id);
  }) });
};

// src/table/table.fx.tsx
import { jsx as jsx22 } from "theme-ui/jsx-runtime";
var withSelectColumn = (_a) => {
  var _b = _a, {
    columns,
    expandOnSelect
  } = _b, rest = __objRest(_b, [
    "columns",
    "expandOnSelect"
  ]);
  const select = {
    id: "select",
    size: 12,
    header: ({ table }) => !rest.singleSelect && /* @__PURE__ */ jsx22(
      Checkbox,
      __spreadValues({}, {
        checked: table.getIsAllRowsSelected(),
        indeterminate: table.getIsSomeRowsSelected(),
        onChange: (e) => {
          table.getToggleAllRowsSelectedHandler()(e);
          if (expandOnSelect) {
            table.getToggleAllRowsExpandedHandler()(e);
          }
        }
      })
    ),
    cell: ({ row }) => rest.singleSelect ? /* @__PURE__ */ jsx22(
      Radio,
      __spreadValues({
        name: rest.singleSelectGroupName
      }, {
        sx: {
          marginLeft: `${row.depth * 2}rem`,
          cursor: row.getCanSelect() ? "pointer" : "not-allowed"
        },
        checked: row.getIsSelected(),
        disabled: !row.getCanSelect(),
        onChange: (e) => {
          row.getToggleSelectedHandler()(e);
          if (expandOnSelect) {
            row.getToggleExpandedHandler()();
          }
        }
      })
    ) : /* @__PURE__ */ jsx22(
      Checkbox,
      __spreadValues({}, {
        sx: { marginLeft: `${row.depth * 2}rem` },
        checked: row.getIsSelected(),
        indeterminate: row.getIsSomeSelected(),
        disabled: !row.getCanSelect(),
        onChange: (e) => {
          row.getToggleSelectedHandler()(e);
          if (expandOnSelect) {
            row.getToggleExpandedHandler()();
          }
        }
      })
    )
  };
  return [select, ...columns];
};
var withExpandColumn = ({
  columns,
  expandOnSelect
}) => {
  if (expandOnSelect) {
    return [...columns];
  }
  const expand = {
    id: "expand",
    size: 12,
    maxSize: 42,
    header: ({ table }) => /* @__PURE__ */ jsx22(
      Button,
      __spreadValues({}, {
        onClick: table.getToggleAllRowsExpandedHandler(),
        icon: {
          name: table.getIsAllRowsExpanded() ? "expand_less" : "expand_more"
        },
        variant: "ghost"
      })
    ),
    cell: ({ row }) => row.getCanExpand() && /* @__PURE__ */ jsx22(
      Button,
      __spreadValues({}, {
        sx: { marginLeft: `${row.depth * 2}rem` },
        onClick: row.getToggleExpandedHandler(),
        icon: { name: row.getIsExpanded() ? "expand_less" : "expand_more" },
        variant: "ghost"
      })
    )
  };
  return [expand, ...columns];
};

// src/table/table.header.tsx
import { flexRender as flexRender2 } from "@tanstack/react-table";
import { jsx as jsx23 } from "theme-ui/jsx-runtime";
var TableHeader = ({ getHeaderGroups }) => {
  const darkMode = useIsDarkMode();
  return /* @__PURE__ */ jsx23(
    "thead",
    {
      sx: {
        backgroundColor: darkMode ? "b-600" : "b-200",
        position: "sticky",
        top: 0
      },
      children: getHeaderGroups().map((headerGroup) => /* @__PURE__ */ jsx23("tr", { children: headerGroup.headers.map((header) => /* @__PURE__ */ jsx23(
        "th",
        {
          colSpan: header.colSpan,
          sx: {
            width: header.getSize(),
            paddingY: "xs",
            paddingX: "md",
            textAlign: "left"
          },
          children: !header.isPlaceholder && flexRender2(header.column.columnDef.header, header.getContext())
        },
        header.id
      )) }, headerGroup.id))
    }
  );
};

// src/table/table.pagination.tsx
import { Box, Flex as Flex4 } from "theme-ui";
import { jsx as jsx24, jsxs as jsxs9 } from "theme-ui/jsx-runtime";
var TablePagination = (props) => {
  const {
    setPageIndex,
    getCanPreviousPage,
    previousPage,
    getState,
    getPageCount,
    nextPage,
    getCanNextPage
  } = props;
  return /* @__PURE__ */ jsxs9(Flex4, { sx: { marginY: "md", gap: "sm", justifyContent: "center" }, children: [
    /* @__PURE__ */ jsx24(
      Button,
      {
        onClick: () => setPageIndex(0),
        disabled: !getCanPreviousPage(),
        icon: { name: "first_page" }
      }
    ),
    /* @__PURE__ */ jsx24(
      Button,
      {
        onClick: () => previousPage(),
        disabled: !getCanPreviousPage(),
        icon: { name: "navigate_before" }
      }
    ),
    /* @__PURE__ */ jsx24(Box, { sx: { width: "10rem", textAlign: "center" }, children: /* @__PURE__ */ jsxs9(Text, { children: [
      "Page",
      " ",
      /* @__PURE__ */ jsx24(Text, { as: "span", variant: "eyebrow", inline: true, children: getState().pagination.pageIndex + 1 }),
      " ",
      "of",
      " ",
      /* @__PURE__ */ jsx24(Text, { as: "span", variant: "eyebrow", inline: true, children: getPageCount() })
    ] }) }),
    /* @__PURE__ */ jsx24(
      Button,
      {
        onClick: () => nextPage(),
        disabled: !getCanNextPage(),
        icon: { name: "navigate_next" }
      }
    ),
    /* @__PURE__ */ jsx24(
      Button,
      {
        onClick: () => setPageIndex(getPageCount() - 1),
        disabled: !getCanNextPage(),
        icon: { name: "last_page" }
      }
    )
  ] });
};

// src/table/table.tsx
import { Fragment as Fragment2, jsx as jsx25, jsxs as jsxs10 } from "theme-ui/jsx-runtime";
var Table2 = (_a) => {
  var _b = _a, {
    data,
    columns,
    pageSize,
    enableExpanding,
    enableSorting,
    enableFilters,
    enableRowSelection,
    expandOnSelect,
    renderSubComponent,
    onChange
  } = _b, rest = __objRest(_b, [
    "data",
    "columns",
    "pageSize",
    "enableExpanding",
    "enableSorting",
    "enableFilters",
    "enableRowSelection",
    "expandOnSelect",
    "renderSubComponent",
    "onChange"
  ]);
  if (pageSize && pageSize < 1) {
    throw new Error("Page size must be greater than or equal to 1");
  }
  const memoizedData = useMemo4(() => [...data], [data]);
  const memoizedColumns = useMemo4(() => {
    let modifiedColumns = columns;
    if (enableRowSelection) {
      modifiedColumns = withSelectColumn(__spreadValues({
        columns: modifiedColumns,
        expandOnSelect
      }, rest));
    }
    if (enableExpanding) {
      modifiedColumns = withExpandColumn({
        columns: modifiedColumns,
        expandOnSelect
      });
    }
    return modifiedColumns;
  }, [columns, expandOnSelect, enableExpanding, enableRowSelection, rest]);
  const table = useReactTable({
    data: memoizedData,
    columns: memoizedColumns,
    enableRowSelection,
    enableMultiRowSelection: !rest.singleSelect,
    enableSorting,
    enableFilters,
    enableExpanding,
    getRowCanExpand: (row) => renderSubComponent ? !!renderSubComponent({ row }) : !!row.subRows.length,
    getIsRowExpanded: enableExpanding && expandOnSelect && enableRowSelection ? (row) => row.getIsSelected() : void 0,
    getSubRows: (row) => row.subRows,
    getCoreRowModel: getCoreRowModel(),
    getPaginationRowModel: pageSize ? getPaginationRowModel() : void 0,
    getFilteredRowModel: enableFilters ? getFilteredRowModel() : void 0,
    getExpandedRowModel: enableExpanding ? getExpandedRowModel() : void 0,
    getSortedRowModel: enableSorting ? getSortedRowModel() : void 0
  });
  const { setPageSize } = table;
  const { rows } = table.getRowModel();
  const state = table.getState();
  const previousState = usePrevious(state);
  useEffect2(() => {
    if (!onChange)
      return;
    if (isDeepEqual(state, previousState))
      return;
    onChange(state);
  }, [state, previousState, onChange]);
  useEffect2(() => {
    if (pageSize) {
      setPageSize(pageSize);
    }
  }, [setPageSize, pageSize]);
  return /* @__PURE__ */ jsxs10(Fragment2, { children: [
    /* @__PURE__ */ jsxs10("table", { sx: { width: "100%", borderRadius: "xl", overflow: "clip" }, children: [
      /* @__PURE__ */ jsx25(TableHeader, __spreadValues({}, table)),
      /* @__PURE__ */ jsx25(TableBody, { rows, renderSubComponent })
    ] }),
    pageSize && /* @__PURE__ */ jsx25(TablePagination, __spreadValues({}, table))
  ] });
};
var VirtualizedTable = (_a) => {
  var _b = _a, {
    data,
    columns,
    pageSize,
    enableExpanding,
    enableSorting,
    enableFilters,
    enableRowSelection,
    expandOnSelect,
    renderSubComponent,
    onChange
  } = _b, rest = __objRest(_b, [
    "data",
    "columns",
    "pageSize",
    "enableExpanding",
    "enableSorting",
    "enableFilters",
    "enableRowSelection",
    "expandOnSelect",
    "renderSubComponent",
    "onChange"
  ]);
  if (pageSize && pageSize < 1) {
    throw new Error("Page size must be greater than or equal to 1");
  }
  const memoizedData = useMemo4(() => [...data], [data]);
  const memoizedColumns = useMemo4(() => {
    let modifiedColumns = columns;
    if (enableRowSelection) {
      modifiedColumns = withSelectColumn(__spreadValues({
        columns: modifiedColumns,
        expandOnSelect
      }, rest));
    }
    if (enableExpanding) {
      modifiedColumns = withExpandColumn({
        columns: modifiedColumns,
        expandOnSelect
      });
    }
    return modifiedColumns;
  }, [columns, expandOnSelect, enableExpanding, enableRowSelection, rest]);
  const table = useReactTable({
    data: memoizedData,
    columns: memoizedColumns,
    enableRowSelection,
    enableMultiRowSelection: !rest.singleSelect,
    enableSorting,
    enableFilters,
    enableExpanding,
    getRowCanExpand: (row) => renderSubComponent ? !!renderSubComponent({ row }) : !!row.subRows.length,
    getIsRowExpanded: enableExpanding && expandOnSelect && enableRowSelection ? (row) => row.getIsSelected() : void 0,
    getSubRows: (row) => row.subRows,
    getCoreRowModel: getCoreRowModel(),
    getPaginationRowModel: pageSize ? getPaginationRowModel() : void 0,
    getFilteredRowModel: enableFilters ? getFilteredRowModel() : void 0,
    getExpandedRowModel: enableExpanding ? getExpandedRowModel() : void 0,
    getSortedRowModel: enableSorting ? getSortedRowModel() : void 0
  });
  const { setPageSize } = table;
  const tableContainerRef = useRef2(null);
  const { rows } = table.getRowModel();
  const state = table.getState();
  const previousState = usePrevious(state);
  const virtualizer = useVirtualizer({
    count: rows.length,
    getScrollElement: () => tableContainerRef.current,
    estimateSize: () => 34,
    overscan: 10
  });
  useEffect2(() => {
    if (pageSize) {
      setPageSize(pageSize);
    }
  }, [setPageSize, pageSize]);
  useEffect2(() => {
    if (!onChange)
      return;
    if (isDeepEqual(state, previousState))
      return;
    onChange(state);
  }, [state, previousState, onChange]);
  const _a2 = rest, { singleSelect: _ } = _a2, styles = __objRest(_a2, ["singleSelect"]);
  return /* @__PURE__ */ jsx25(
    "div",
    {
      ref: tableContainerRef,
      sx: __spreadProps(__spreadValues({}, styles), { borderRadius: "xl", overflow: "auto" }),
      children: /* @__PURE__ */ jsxs10("table", { sx: { width: "100%", borderRadius: "xl", overflow: "clip" }, children: [
        /* @__PURE__ */ jsx25(TableHeader, __spreadValues({}, table)),
        /* @__PURE__ */ jsx25(
          TableBody,
          {
            rows,
            virtualizer,
            renderSubComponent
          }
        )
      ] })
    }
  );
};
Table2.Virtualized = VirtualizedTable;
export {
  Anchor,
  Button,
  ButtonGroup,
  Card,
  CardButton,
  Checkbox,
  Code,
  CodeBlock,
  Icon,
  InputContainer,
  Label,
  Overlay,
  Radio,
  Spinner,
  SpinnerContext,
  SpinnerProvider,
  Table2 as Table,
  Text,
  VirtualizedTable,
  useIsDarkMode,
  useSpinner,
  useSpinnerContext,
  withSpinner
};
